<?php

namespace Wappointment\Controllers;

use Wappointment\Services\Settings;
use Wappointment\Services\WidgetSettings;
use Wappointment\Services\TestMail;
use Wappointment\ClassConnect\Request;
class SettingsController extends \Wappointment\Controllers\RestController
{
    public function get(\Wappointment\ClassConnect\Request $request)
    {
        return \Wappointment\Services\Settings::get($request->input('key'));
    }
    public function save(\Wappointment\ClassConnect\Request $request)
    {
        if ($request->input('settings')) {
            foreach ($request->input('settings') as $key => $value) {
                $msg = \Wappointment\Services\Settings::save($key, $value);
            }
            return $msg;
        } else {
            if ($request->input('key') == 'widget') {
                (new \Wappointment\Services\WidgetSettings())->save($request->input('val'));
                return ['message' => 'Settings saved'];
            } else {
                \Wappointment\Services\Settings::save($request->input('key'), $request->input('val'));
                $data = ['message' => 'Settings saved'];
                if ($request->input('key') == 'payments_order') {
                    $data['methods'] = \Wappointment\Services\Payment::methods();
                }
                return $data;
            }
        }
    }
    public function sendPreviewEmail(\Wappointment\ClassConnect\Request $request)
    {
        $resultEmail = \Wappointment\Services\TestMail::send($request->input('data'), $request->input('recipient'));
        if ($this->isTrueOrFail($resultEmail)) {
            \Wappointment\Services\Settings::save('mail_config', $request->input('data'));
            \Wappointment\Services\Settings::save('mail_status', true);
            return ['message' => 'Configuration completed! Check your inbox for the test email just sent to your address.'];
        } else {
            if (\Wappointment\ClassConnect\Str::contains($resultEmail['error'], ['username', 'password', 'login', 'user', 'credentials'])) {
                $this->setError('There seems to be a problem with the credentials you are using.');
                $this->setError($resultEmail['error'], 'debug');
            } else {
                $this->setError('Couldn\'t send test email.');
                $this->setError($resultEmail['error'], 'debug');
            }
        }
    }
}
