<?php

namespace Wappointment\Controllers;

use Wappointment\Services\Wappointment\EmailList;
use Wappointment\Services\Wappointment\Contact;
use Wappointment\Services\Wappointment\BookingTest as BookingTestAPI;
use Wappointment\Services\BookingTest;
use Wappointment\Validators\HttpRequest\SubscribeAdmin;
use Wappointment\Validators\HttpRequest\ContactAdmin;
use Wappointment\Services\Settings;
use Wappointment\WP\Helpers as WPHelpers;
class WappointmentController extends \Wappointment\Controllers\RestController
{
    public function subscribe(\Wappointment\Validators\HttpRequest\SubscribeAdmin $request)
    {
        $result = (new \Wappointment\Services\Wappointment\EmailList())->subscribe($request->get('email'), $request->get('list'));
        if ($result) {
            return ['result' => $result, 'message' => $result === true ? 'Already subscribed' : (isset($result['response']->status) && $result['response']->status > 0 ? "Great, we'll keep you posted as soon as this is out!" : 'Great we\'ve sent you an email, just quickly check your inbox and confirm!')];
        }
        throw new \WappointmentException("Couldn't subscribe you.", 1);
    }
    public function contact(\Wappointment\Validators\HttpRequest\ContactAdmin $request)
    {
        $result = (new \Wappointment\Services\Wappointment\Contact())->sendMessage($request);
        if ($result) {
            return ['result' => $result, 'message' => 'Great your message has been sent, we\'ll get back to you soon'];
        }
        throw new \WappointmentException("Couldn't send your message.", 1);
    }
    public function sendTestBooking($request)
    {
        (new \Wappointment\Services\Wappointment\BookingTest())->record($request);
        $result = (new \Wappointment\Services\BookingTest())->send();
        // quickly trigger the queue task
        \Wappointment\WP\Helpers::cronTrigger();
        if ($result) {
            \Wappointment\Services\Settings::save('show_welcome', false);
            return ['result' => true, 'message' => "Alright we just created a test appointment"];
        }
        return ['result' => false, 'message' => "We couldn't send test email"];
    }
    public function sendIgnoreBooking()
    {
        \Wappointment\Services\Settings::save('show_welcome', false);
        return ['result' => true, 'message' => "Have fun!"];
    }
}
