<?php

namespace Wappointment\Repositories;

use Wappointment\Managers\Central;
use Wappointment\Services\CurrentUser;
use Wappointment\WP\Staff;
class CalendarsBack extends \Wappointment\Repositories\AbstractRepository
{
    use MustRefreshAvailability;
    public $cache_key = 'calendars_back';
    public function query()
    {
        $calendarsQry = \Wappointment\Managers\Central::get('CalendarModel')::orderBy('sorting')->with(['services']);
        if (!\Wappointment\Services\CurrentUser::isAdmin()) {
            $calendarsQry->where('id', \Wappointment\Services\CurrentUser::calendarId());
        }
        $calendars = $calendarsQry->fetch();
        $staffs = [];
        foreach ($calendars->toArray() as $calendar) {
            $staffs[] = (new \Wappointment\WP\Staff($calendar))->fullData();
        }
        $this->refreshAvailability();
        return $staffs;
    }
}
